******* CarbonCopy.man *******************************************************
*
*   $VER: CarbonCopy V34.8 (06-Mar-93) -- A FSC-0039 MultiMatrix Utility.
*
*               Written by Klaus Seistrup @ FidoNet 2:230/119
*
******************************************************************************


    FUNCTION
        CarbonCopy is a FidoNet Technical Networks utility that will create
        FSC-0039 style packets, given a plain ASCII text file and a list of
        nodes to send netmails to. You'll need a TrapList parsed NodeList
        to accomplish this...

        CarbonCopy is for netmails only, but you might like to try CrossPost
        written by SUne Trudslev (former 2:230/415@fidonet) for making multiple
        postings in echomail areas.


    SYNTAX
        CarbonCopy -f FromFQFA -s Subject -t TextFile -d Directory [HOLD|CRASH]
                   @ List ToFQFA/... [NOCC] [NOORIGINAL] [FORCEINTL]

            FromFQFA    FQFA of sender ($SYSNODE)
            Subject     Subject ("Important message")
            TextFile    Full path and name of text file to send (CC.txt)
            Directory   Where to put the PKT file(s) ($INBOUND|MAIL:Inbound/)
            HOLD|CRASH  Set HOLD|CRASH attributes (not really useful)
            ToFQFA      FQFA of addressee(s)
            List        Optional list of addressee(s)
            NOCC        Skip "CC: [...]" header
            NOORIGINAL  Don't put any " * Original to [...]"
            FORCEINTL   Force ^aINTL kludge


        CarbonCopy is neither sensitive to the ordering of arguments, nor
        case-sensitive.

        FROMFQFA defaults to the FQFA found in $SYSNODE. The $SYSNODE
        address can be overridden by specifying an address on the command
        line.

        DIRECTORY could be anywhere on your system, but specifying your
        inbound directory is an easy solution, since it will then be up
        to your tosser to do the routing. :-) Defaults to $INBOUND or, if
        not found, MAIL:Inbound/.

        HOLD|CRASH will set the appropriate attributes for the *.PKT
        following the keyword. If you're using Foozle as your tosser
        this is not really useful, since Foozle will 'strip off' the
        attributes and put whatever you've specified in FzI instead.
        Anyways, these two keywords are available for those who like. :-)

        TOFQFA takes as many node addresses as needed, but if you have a
        numerous list, you might like the LIST option: LIST points to a
        plain text file with one node address per line. Characters ';'
        and '#' can be used for commenting.

        FORCEINTL will force a ^aINTL kludge - even if the source and
        destination zones are the same. This is popular on some systems.


    NOTES
        Fully re-entrant ("PURE").
        Requires traplist.library V4+.
        Runs smoothly under AmigaOS 1.3+.

        CarbonCopy replaces all LF (ASCII 10) with CRLF (ASCII 13+10),
        but I might implement a REFLOW switch ( la Foozle) in future
        versions. If you need this, please lemme know...

        CarbonCopy creates a temporary file in T: before creating the
        PKTs.

        CarbonCopy searches for the NodeList in the directory found in
        $NODELIST -- defaults to NODELIST:.

        Do NOT abuse this program for netmail bombings! Remember that
        the names of the addressees will all be put into each packet
        created by CarbonCopy -- and even a small text file might end
        up as fairly big PKTs if your list is extensive...!

        CarbonCopy is rather big because it's 1.3 compatible. If you
        guys wants a smaller - but OS2.0-only - version, please netmail
        me! If enough people wants the 2.0 version (who's running 1.3
        now, after all?), I'll make it. :-)


    ACKNOWLEDGEMENTS
        For beta testing and suggestions, sincere thanks are due to:

            Thomas Agatz     (2:230/311@fidonet)
            Mark Cassidy     (2:230/611@fidonet)    <--  DOWN!
            Wim Peeters      (2:291/708@fidonet)
            Steffen Salzmann (2:249/125.2@fidonet)

        Also a great many thanks to Matt Dillon for his wonderful DICE
        compiler. 8-d;)


    COPYRIGHT
        CarbonCopy is Copyright (C) 1992,93 Magnetic Ink, but freely
        redistributable as, of course, CarbonCopyWare. q;) If you like
        this program and use it regularly, you are obliged to send a
        carbon copy of the postcard included in the distribution archive
        (please insert your own name!) to one of the following addresses:

                    2:230/119@fidonet
                    92:910/102@badnet

                    InterNet: kleis@magneto.bbs.bad.se


    HISTORY
        34.1-34.4   Beta releases
        34.5        First public release
        34.6        Added $INBOUND (Mark Cassidy)
        34.7        Added HOLD|CRASH attributes (Wim Peeters)
        34.8        Fixed the ^aINTL bug.
                    Added FORCEINTL keyword.
                    Should be more OS 2.04+ aware now.
                    CC will now also send a copy to sender (Steffen Salzmann)

